package ch.psi.daq.rest;

import java.util.UUID;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.psi.daq.cassandra.writer.CassandraWriter;
import ch.psi.daq.domain.cassandra.ChannelEvent;
import ch.psi.daq.rest.queries.PulseRangeQuery;

@RestController
public class DaqController {

   private static final Logger logger = LoggerFactory.getLogger(DaqController.class);

   @Autowired
   private CassandraWriter writer;

   @RequestMapping(value = "/test")
   public void queryIndices() {

      logger.info("TEST endpoint invoked");

      long pulseId = System.currentTimeMillis();
      String value = "data_" + UUID.randomUUID().toString();

      writer.writeAsync(1, 0, new ChannelEvent("dummyChannel", pulseId, 0, pulseId, pulseId, 0, value));
   }
   
   @RequestMapping(value = "/pulserange")
   public void pulseRange(@RequestBody PulseRangeQuery query) {

      logger.info("PulseRangeQuery received: {}", query);

      
   }
}
