package ch.psi.daq.rest.queries;

import java.util.LinkedHashSet;
import java.util.List;

import org.apache.commons.lang.builder.ToStringBuilder;

import ch.psi.daq.hazelcast.common.query.ValueAggregation;
import ch.psi.daq.rest.model.Aggregation;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;

/**
 * 
 */
public class PulseRangeQuery extends AbstractQuery {

   private long startPulseId;
   private long endPulseId;

   @JsonCreator
   public PulseRangeQuery(
         // note that those annotations are needed for the polymorphic
         // mapping to work correctly
         @JsonProperty(value = "isOrderDescending") boolean isOrderDescending,
         @JsonProperty(value = "channels") List<String> channels,
         @JsonProperty(value = "fields") LinkedHashSet<String> fields,
         @JsonProperty(value = "aggregateChannels") boolean aggregateChannels,
         @JsonProperty(value = "aggregationType") ValueAggregation valueAggregation,
         @JsonProperty(value = "aggregations") List<Aggregation> aggregations,
         @JsonProperty(value = "startPulseId") long startPulseId,
         @JsonProperty(value = "endPulseId") long endPulseId)
   {

      super(isOrderDescending, channels, fields, aggregateChannels, valueAggregation, aggregations);

      this.startPulseId = startPulseId;
      this.endPulseId = endPulseId;
   }

   public long getStartPulseId() {
      return startPulseId;
   }

   public void setStartPulseId(long startPulseId) {
      this.startPulseId = startPulseId;
   }

   public long getEndPulseId() {
      return endPulseId;
   }

   public void setEndPulseId(long endPulseId) {
      this.endPulseId = endPulseId;
   }

   /**
    * {@inheritDoc}
    */
   @Override
   public String toString() {
      return ToStringBuilder.reflectionToString(this);
   }

}
